diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
similarity index 82%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
index a3ca032ef..714072c78 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDoor.java
@@ -7,6 +7,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockDoor;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 
 public class BlockModelDoor<T extends BlockDoor> extends BlockModelStandard<T> {
     public BlockModelDoor(Block block) {
@@ -29,8 +30,8 @@ public class BlockModelDoor<T extends BlockDoor> extends BlockModelStandard<T> {
     		tessellator.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
     	}
     	tessellator.setColorOpaque_F(1.0f, 1.0f, 1.0f);
-    	
-		block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
+
+		AABB bounds = block.getBlockBoundsFromState(renderBlocks.blockAccess, x, y, z);
 
 		float sideBottom = 1.0f;
 		float sideTop = 1.0f;
@@ -51,57 +52,57 @@ public class BlockModelDoor<T extends BlockDoor> extends BlockModelStandard<T> {
 		// Bottom
 		if(!belowIsDoor) {
 			setBrightness(tessellator, x, y - 1, z, sideBottom);
-			renderBottomFace(tessellator, block, x, y, z, getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.BOTTOM));
+			renderBottomFace(tessellator, bounds, x, y, z, getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.BOTTOM));
 		}
 		
 		// Top
 		if(!aboveIsDoor) {
 			setBrightness(tessellator, x, y + 1, z, sideTop);
-			renderTopFace(tessellator, block, x, y, z, getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.TOP));
+			renderTopFace(tessellator, bounds, x, y, z, getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.TOP));
 		}
 		
 		// North
-		if(block.minZ > RenderBlocks.FULL_CUBE_THRESHOLD) {
+		if(bounds.minZ > RenderBlocks.FULL_CUBE_THRESHOLD) {
 			setBrightness(tessellator, x, y, z, sideNorthSouth);
 		}else {
 			setBrightness(tessellator, x, y, z - 1, sideNorthSouth);
 		}
 		renderBlocks.flipTexture = shouldFlipTexture(Side.NORTH, meta);
 		IconCoordinate texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.NORTH);
-		renderNorthFace(tessellator, block, x, y, z, texture);
+		renderNorthFace(tessellator, bounds, x, y, z, texture);
 		renderBlocks.flipTexture = false;
 		
 		// South
-		if(block.maxZ < 1.0f - RenderBlocks.FULL_CUBE_THRESHOLD) {
+		if(bounds.maxZ < 1.0f - RenderBlocks.FULL_CUBE_THRESHOLD) {
 			setBrightness(tessellator, x, y, z, sideNorthSouth);
 		}else {
 			setBrightness(tessellator, x, y, z + 1, sideNorthSouth);
 		}
 		renderBlocks.flipTexture = shouldFlipTexture(Side.SOUTH, meta);
 		texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.SOUTH);
-		renderSouthFace(tessellator, block, x, y, z, texture);
+		renderSouthFace(tessellator, bounds, x, y, z, texture);
 		renderBlocks.flipTexture = false;
 		
 		// West
-		if(block.minX > RenderBlocks.FULL_CUBE_THRESHOLD) {
+		if(bounds.minX > RenderBlocks.FULL_CUBE_THRESHOLD) {
 			setBrightness(tessellator, x, y, z, sideEastWest);
 		}else {
 			setBrightness(tessellator, x - 1, y, z, sideEastWest);
 		}
 		renderBlocks.flipTexture = shouldFlipTexture(Side.WEST, meta);
 		texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.WEST);
-		renderWestFace(tessellator, block, x, y, z, texture);
+		renderWestFace(tessellator, bounds, x, y, z, texture);
 		renderBlocks.flipTexture = false;
 		
 		// East
-		if(block.maxX < 1.0f - RenderBlocks.FULL_CUBE_THRESHOLD) {
+		if(bounds.maxX < 1.0f - RenderBlocks.FULL_CUBE_THRESHOLD) {
 			setBrightness(tessellator, x, y, z, sideEastWest);
 		}else {
 			setBrightness(tessellator, x + 1, y, z, sideEastWest);
 		}
 		renderBlocks.flipTexture = shouldFlipTexture(Side.EAST, meta);
 		texture = getBlockTexture(renderBlocks.blockAccess, x, y, z, Side.EAST);
-		renderEastFace(tessellator, block, x, y, z, texture);
+		renderEastFace(tessellator, bounds, x, y, z, texture);
 		renderBlocks.flipTexture = false;
 		return true;
 	}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
similarity index 92%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
index 3d01103ac..d5455d4dd 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFarmland.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.BlockFarmland;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
 public class BlockModelFarmland<T extends Block> extends BlockModelStandard<T> {
@@ -44,8 +45,8 @@ public class BlockModelFarmland<T extends Block> extends BlockModelStandard<T> {
     }
 
     @Override
-    public boolean shouldSideBeRendered(WorldSource blockAccess, int x, int y, int z, int side) {
+    public boolean shouldSideBeRendered(WorldSource blockAccess, AABB bounds, int x, int y, int z, int side) {
         if (side >= 2 && blockAccess.getBlockId(x, y, z) == Blocks.FARMLAND_DIRT.id) return false;
-        return super.shouldSideBeRendered(blockAccess, x, y, z, side);
+        return super.shouldSideBeRendered(blockAccess, bounds, x, y, z, side);
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
similarity index 61%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
index 4829a7b28..3b21d2d7c 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFence.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockFence;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -15,12 +16,10 @@ public class BlockModelFence<T  extends BlockFence> extends BlockModelStandard<T
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         final float f = 0.375F;
         final float f1 = 0.625F;
-        block.setBlockBounds(f, 0.0F, f, f1, 1.0F, f1);
-        block.setBlockBounds(f, 0.0F, f, f1, 1.0F, f1);
-        renderStandardBlock(tessellator, block, x, y, z);
+        AABB bounds = AABB.getTemporaryBB(f, 0.0F, f, f1, 1.0F, f1);
+        renderStandardBlock(tessellator, bounds, x, y, z);
         boolean flag1 = false;
         boolean flag2 = false;
         if(block.canConnectTo(renderBlocks.blockAccess, x - 1, y, z) || block.canConnectTo(renderBlocks.blockAccess, x + 1, y, z))
@@ -49,27 +48,26 @@ public class BlockModelFence<T  extends BlockFence> extends BlockModelStandard<T
         final float f7 = flag6 ? 1.0F : f9;
         if(flag1)
         {
-            block.setBlockBounds(f4, f2, f8, f5, f3, f9);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(f4, f2, f8, f5, f3, f9);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         }
         if(flag2)
         {
-            block.setBlockBounds(f8, f2, f6, f9, f3, f7);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(f8, f2, f6, f9, f3, f7);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         }
         final float f10 = 0.375F;
         final float f11 = 0.5625F;
         if(flag1)
         {
-            block.setBlockBounds(f4, f10, f8, f5, f11, f9);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(f4, f10, f8, f5, f11, f9);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         }
         if(flag2)
         {
-            block.setBlockBounds(f8, f10, f6, f9, f11, f7);
-            renderStandardBlock(tessellator, block, x, y, z);
+            bounds.set(f8, f10, f6, f9, f11, f7);
+            renderStandardBlock(tessellator, bounds, x, y, z);
         }
-        block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         return true;
     }
 
@@ -86,58 +84,58 @@ public class BlockModelFence<T  extends BlockFence> extends BlockModelStandard<T
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
         for(int cube = 0; cube < 4; cube++)
         {
-            // Vertical Beams
+
+            AABB bounds;
             final float radius = 0.125F;
-            if(cube == 0)
-            {
-                block.setBlockBounds(0.5F - radius, 0.0F, 0.0F, 0.5F + radius, 1.0F, radius * 2.0F);
-            }
-            if(cube == 1)
-            {
-                block.setBlockBounds(0.5F - radius, 0.0F, 1.0F - radius * 2.0F, 0.5F + radius, 1.0F, 1.0F);
-            }
-            // Horizontal Beams
             final float f5 = 0.0625F;
-            if(cube == 2)
-            {
-                block.setBlockBounds(0.5F - f5, 1.0F - f5 * 3F, -f5 * 2.0F, 0.5F + f5, 1.0F - f5, 1.0F + f5 * 2.0F);
-            }
-            if(cube == 3)
-            {
-                block.setBlockBounds(0.5F - f5, 0.5F - f5 * 3F, -f5 * 2.0F, 0.5F + f5, 0.5F - f5, 1.0F + f5 * 2.0F);
+            switch (cube) {
+                // Vertical Beams
+                case 0:
+                    bounds = AABB.getTemporaryBB(0.5F - radius, 0.0F, 0.0F, 0.5F + radius, 1.0F, radius * 2.0F);
+                    break;
+                case 1:
+                    bounds = AABB.getTemporaryBB(0.5F - radius, 0.0F, 1.0F - radius * 2.0F, 0.5F + radius, 1.0F, 1.0F);
+                    break;
+                // Horizontal Beams
+                case 2:
+                    bounds = AABB.getTemporaryBB(0.5F - f5, 1.0F - f5 * 3F, -f5 * 2.0F, 0.5F + f5, 1.0F - f5, 1.0F + f5 * 2.0F);
+                    break;
+                case 3:
+                default:
+                    bounds = AABB.getTemporaryBB(0.5F - f5, 0.5F - f5 * 3F, -f5 * 2.0F, 0.5F + f5, 0.5F - f5, 1.0F + f5 * 2.0F);
+                    break;
             }
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, -1F, 0.0F);
-            renderBottomFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
+            renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 1.0F, 0.0F);
-            renderTopFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
+            renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, -1F);
-            renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
+            renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, 1.0F);
-            renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
+            renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(-1F, 0.0F, 0.0F);
-            renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
+            renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
             tessellator.draw();
 
             tessellator.startDrawingQuads();
             tessellator.setNormal(1.0F, 0.0F, 0.0F);
-            renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
+            renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
             tessellator.draw();
         }
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
-        block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
new file mode 100644
index 000000000..617c77436
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
@@ -0,0 +1,224 @@
+package net.minecraft.client.render.block.model;
+
+import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockFenceGate;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.util.phys.AABB;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.opengl.GL11;
+
+public class BlockModelFenceGate<T extends BlockFenceGate> extends BlockModelStandard<T> {
+    public BlockModelFenceGate(Block block) {
+        super(block);
+    }
+
+    @Override
+    public boolean render(Tessellator tessellator, int x, int y, int z) {
+        AABB bounds = block.getBounds();
+        boolean flag = true;
+        int l = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+        boolean flag1 = BlockFenceGate.isOpen(l);
+        int i1 = BlockFenceGate.getDirection(l);
+        if(i1 == 3 || i1 == 1)
+        {
+            float f = 0.4375F;
+            float f4 = 0.5625F;
+            float f8 = 0.0F;
+            float f12 = 0.125F;
+            bounds.set(f, 0.3125F, f8, f4, 1.0F, f12);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            f8 = 0.875F;
+            f12 = 1.0F;
+            bounds.set(f, 0.3125F, f8, f4, 1.0F, f12);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+        } else
+        {
+            float f1 = 0.0F;
+            float f5 = 0.125F;
+            float f9 = 0.4375F;
+            float f13 = 0.5625F;
+            bounds.set(f1, 0.3125F, f9, f5, 1.0F, f13);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            f1 = 0.875F;
+            f5 = 1.0F;
+            bounds.set(f1, 0.3125F, f9, f5, 1.0F, f13);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+        }
+        if(!flag1)
+        {
+            if(i1 == 3 || i1 == 1)
+            {
+                float f2 = 0.4375F;
+                float f6 = 0.5625F;
+                float f10 = 0.375F;
+                float f14 = 0.5F;
+                bounds.set(f2, 0.375F, f10, f6, 0.9375F, f14);
+                renderStandardBlock(tessellator, bounds, x, y, z);
+                f10 = 0.5F;
+                f14 = 0.625F;
+                bounds.set(f2, 0.375F, f10, f6, 0.9375F, f14);
+                renderStandardBlock(tessellator, bounds, x, y, z);
+                f10 = 0.625F;
+                f14 = 0.875F;
+                bounds.set(f2, 0.375F, f10, f6, 0.5625F, f14);
+                renderStandardBlock(tessellator, bounds, x, y, z);
+                bounds.set(f2, 0.75F, f10, f6, 0.9375F, f14);
+                renderStandardBlock(tessellator, bounds, x, y, z);
+                f10 = 0.125F;
+                f14 = 0.375F;
+                bounds.set(f2, 0.375F, f10, f6, 0.5625F, f14);
+                renderStandardBlock(tessellator, bounds, x, y, z);
+                bounds.set(f2, 0.75F, f10, f6, 0.9375F, f14);
+                renderStandardBlock(tessellator, bounds, x, y, z);
+            } else
+            {
+                float f3 = 0.375F;
+                float f7 = 0.5F;
+                float f11 = 0.4375F;
+                float f15 = 0.5625F;
+                bounds.set(f3, 0.375F, f11, f7, 0.9375F, f15);
+                renderStandardBlock(tessellator, bounds, x, y, z);
+                f3 = 0.5F;
+                f7 = 0.625F;
+                bounds.set(f3, 0.375F, f11, f7, 0.9375F, f15);
+                renderStandardBlock(tessellator, bounds, x, y, z);
+                f3 = 0.625F;
+                f7 = 0.875F;
+                bounds.set(f3, 0.375F, f11, f7, 0.5625F, f15);
+                renderStandardBlock(tessellator, bounds, x, y, z);
+                bounds.set(f3, 0.75F, f11, f7, 0.9375F, f15);
+                renderStandardBlock(tessellator, bounds, x, y, z);
+                f3 = 0.125F;
+                f7 = 0.375F;
+                bounds.set(f3, 0.375F, f11, f7, 0.5625F, f15);
+                renderStandardBlock(tessellator, bounds, x, y, z);
+                bounds.set(f3, 0.75F, f11, f7, 0.9375F, f15);
+                renderStandardBlock(tessellator, bounds, x, y, z);
+            }
+        } else
+        if(i1 == 3)
+        {
+            bounds.set(0.8125F, 0.375F, 0.0F, 0.9375F, 0.9375F, 0.125F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.8125F, 0.375F, 0.875F, 0.9375F, 0.9375F, 1.0F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.5625F, 0.375F, 0.0F, 0.8125F, 0.5625F, 0.125F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.5625F, 0.375F, 0.875F, 0.8125F, 0.5625F, 1.0F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.5625F, 0.75F, 0.0F, 0.8125F, 0.9375F, 0.125F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.5625F, 0.75F, 0.875F, 0.8125F, 0.9375F, 1.0F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+        } else
+        if(i1 == 1)
+        {
+            bounds.set(0.0625F, 0.375F, 0.0F, 0.1875F, 0.9375F, 0.125F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.0625F, 0.375F, 0.875F, 0.1875F, 0.9375F, 1.0F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.1875F, 0.375F, 0.0F, 0.4375F, 0.5625F, 0.125F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.1875F, 0.375F, 0.875F, 0.4375F, 0.5625F, 1.0F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.1875F, 0.75F, 0.0F, 0.4375F, 0.9375F, 0.125F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.1875F, 0.75F, 0.875F, 0.4375F, 0.9375F, 1.0F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+        } else
+        if(i1 == 0)
+        {
+            bounds.set(0.0F, 0.375F, 0.8125F, 0.125F, 0.9375F, 0.9375F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.875F, 0.375F, 0.8125F, 1.0F, 0.9375F, 0.9375F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.0F, 0.375F, 0.5625F, 0.125F, 0.5625F, 0.8125F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.875F, 0.375F, 0.5625F, 1.0F, 0.5625F, 0.8125F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.0F, 0.75F, 0.5625F, 0.125F, 0.9375F, 0.8125F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.875F, 0.75F, 0.5625F, 1.0F, 0.9375F, 0.8125F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+        } else
+        if(i1 == 2)
+        {
+            bounds.set(0.0F, 0.375F, 0.0625F, 0.125F, 0.9375F, 0.1875F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.875F, 0.375F, 0.0625F, 1.0F, 0.9375F, 0.1875F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.0F, 0.375F, 0.1875F, 0.125F, 0.5625F, 0.4375F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.875F, 0.375F, 0.1875F, 1.0F, 0.5625F, 0.4375F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.0F, 0.75F, 0.1875F, 0.125F, 0.9375F, 0.4375F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+            bounds.set(0.875F, 0.75F, 0.1875F, 1.0F, 0.9375F, 0.4375F);
+            renderStandardBlock(tessellator, bounds, x, y, z);
+        }
+        return flag;
+    }
+
+    @Override
+    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        if(renderBlocks.useInventoryTint)
+        {
+            int j = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata);
+            float f1 = (float)(j >> 16 & 0xff) / 255F;
+            float f3 = (float)(j >> 8 & 0xff) / 255F;
+            float f5 = (float)(j & 0xff) / 255F;
+            GL11.glColor4f(f1 * brightness, f3 * brightness, f5 * brightness, alpha);
+        }
+        for(int k1 = 0; k1 < 3; k1++)
+        {
+            float f6 = 0.0625F;
+            AABB bounds = block.getBounds();
+            if(k1 == 0)
+            {
+                bounds.set(0.5F - f6, 0.3F, 0.0F, 0.5F + f6, 1.0F, f6 * 2.0F);
+            }
+            if(k1 == 1)
+            {
+                bounds.set(0.5F - f6, 0.3F, 1.0F - f6 * 2.0F, 0.5F + f6, 1.0F, 1.0F);
+            }
+            if(k1 == 2)
+            {
+                bounds.set(0.5F - f6, 0.5F, 0.0F, 0.5F + f6, 1.0F - f6, 1.0F);
+            }
+            GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
+            tessellator.startDrawingQuads();
+            tessellator.setNormal(0.0F, -1F, 0.0F);
+            renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
+            tessellator.draw();
+
+            tessellator.startDrawingQuads();
+            tessellator.setNormal(0.0F, 1.0F, 0.0F);
+            renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
+            tessellator.draw();
+
+            tessellator.startDrawingQuads();
+            tessellator.setNormal(0.0F, 0.0F, -1F);
+            renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
+            tessellator.draw();
+
+            tessellator.startDrawingQuads();
+            tessellator.setNormal(0.0F, 0.0F, 1.0F);
+            renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
+            tessellator.draw();
+
+            tessellator.startDrawingQuads();
+            tessellator.setNormal(-1F, 0.0F, 0.0F);
+            renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
+            tessellator.draw();
+
+            tessellator.startDrawingQuads();
+            tessellator.setNormal(1.0F, 0.0F, 0.0F);
+            renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
+            tessellator.draw();
+            GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+        }
+    }
+
+}
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
similarity index 96%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
index 6127db045..b3111e2ed 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
@@ -8,6 +8,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockFenceThin;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
@@ -26,7 +27,6 @@ public class BlockModelFenceThin<T extends BlockFenceThin> extends BlockModelSta
     }
     @Override
     public boolean render(Tessellator t, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
         	t.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
@@ -360,11 +360,12 @@ public class BlockModelFenceThin<T extends BlockFenceThin> extends BlockModelSta
             GL11.glColor4f(f1 * brightness, f3 * brightness, f5 * brightness, alpha);
         }
         GL11.glRotatef(90, 0, 1, 0);
+        AABB bounds = AABB.getTemporaryBB(0, 0, 0, 1, 1, 1);
         for(int i1 = 0; i1 < 2; i1++)
         {
             GL11.glPushMatrix();
             float f4 = 0.125F / 2;
-            block.setBlockBounds(0, 0.0F, 0.0F, 2 * f4, 1.0F, f4 * 2.0F);
+            bounds.set(0, 0.0F, 0.0F, 2 * f4, 1.0F, f4 * 2.0F);
             GL11.glTranslatef(0.5f - f4, 0, 0);
             if(i1 == 1)
             {
@@ -373,40 +374,43 @@ public class BlockModelFenceThin<T extends BlockFenceThin> extends BlockModelSta
             GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, -1F, 0.0F);
-            renderBottomFace(tessellator, block, 0.0D, 0.0D, 0.0D, columnTexIndex);
+            renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, columnTexIndex);
             tessellator.draw();
+
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 1.0F, 0.0F);
-            renderTopFace(tessellator, block, 0.0D, 0.0D, 0.0D, columnTexIndex);
+            renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, columnTexIndex);
             tessellator.draw();
+
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, -1F);
-            renderNorthFace(tessellator, block, 0.0D, 0.0D, 0.0D, columnTexIndex);
+            renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, columnTexIndex);
             tessellator.draw();
+
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, 1.0F);
-            renderSouthFace(tessellator, block, 0.0D, 0.0D, 0.0D, columnTexIndex);
+            renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, columnTexIndex);
             tessellator.draw();
+
             tessellator.startDrawingQuads();
             tessellator.setNormal(-1F, 0.0F, 0.0F);
-            renderWestFace(tessellator, block, 0.0D, 0.0D, 0.0D, columnTexIndex);
+            renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, columnTexIndex);
             tessellator.draw();
+
             tessellator.startDrawingQuads();
             tessellator.setNormal(1.0F, 0.0F, 0.0F);
-            renderEastFace(tessellator, block, 0.0D, 0.0D, 0.0D, columnTexIndex);
+            renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, columnTexIndex);
             tessellator.draw();
             GL11.glPopMatrix();
         }
 
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
         GL11.glDisable(GL11.GL_CULL_FACE);
-        block.setBlockBounds(0, 0, 0, 0.5f, 1, 1);
+        bounds.set(0, 0, 0, 0.5f, 1, 1);
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
-        renderEastFace(tessellator, block, 0, 0, 0, texIndex);
+        renderEastFace(tessellator, bounds, 0, 0, 0, texIndex);
         tessellator.draw();
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
-
-        block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
similarity index 99%
rename from src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
rename to game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
index 0bbe850cb..5ada4a739 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
@@ -22,7 +22,6 @@ public class BlockModelFire<T extends Block> extends BlockModelStandard<T> {
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
-        block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, renderBlocks.blockAccess.getBlockMetadata(x, y, z));
         if(renderBlocks.overrideBlockTexture != null)
         {
